unit Mystring;
{
  Peter Klauer

  ehemals fr Delphi 1 gestrickt

  einiges scheint nun mit Delphi32 berflssig zu sein.
  Bleibt aber trotzdem drin, weil viele ltere Anwendungen
  diese Unit einbinden.

  Die Routinen Trim, Alltrim, PadR, Replicate, Space, Empty, LeftStr und Right
  sind abgeguckt aus dem Delphi-Forum in Compuserve, ca. 1996.
  Leider kann der wirkliche Author nicht mehr genannt werden, ich wrde ihn (sie)
  hier gerne auffhren.
  Noch leiderer sind mittlerweile einige Funktionen wie Trim, Alltrim u.a. in
  Delphi unter leicht anderem Namen implementiert und damit eigentlich
  flssiger als Wasser - berflssig.

  Fr die Benutzung aller Routinen gibt es - wie immer - KEINE GARANTIE.

  Dauerbrenner, die ich immer einsetze:

    SaveStrToInt, SaveStrToFloat, NolastBackSlash, Space, TokenList.

  knito@knito.de
  www.knito.de

  18. nov 1999

}


interface

uses sysutils, classes;

{ Das ist alles nur geklaut: }
{ Clipper-Stringfunktionen mit Ausnahme von "Left" war nach "Leftstr" }
{ umbenannt wurde. (Wg. Komponenten-Eigenschaft "Left") }
function Trim(cString: string): string;
function AllTrim(cString: string): string;
function PadR(cString: string; nLen: integer): string;
function Replicate(c: char; nLen: integer): string;
function Space(nLen: integer): string;
function Empty(cString: string): boolean;
function LeftStr(cString: string; nLen: integer): string;
function Right(cString: string; nLen: integer): string;

{Ab hier ist alles von Knito:}

{
  Umwandlung ohne Motz von Delphi
}
function SaveIntToStr( x : longint ) : string;
function SaveStrToInt( s : string ) : longint;
function SaveStrToFloat( s : string ) : Extended;

function IntToNullStr(x, stellen : longint) : string;
function IntToSpaceStr(x, stellen : longint) : string;

{
  Keine Clipperfunktionen, aber fr den ordnungsgemen Betrieb von
  Sch...Delphi erforderlich:
}
function doubletoint( x : double ): longint;
function inttodouble( x : longint ) : double;

{Braucht man ab und zu, alles von Knito}
function lastpos(substring, s : string ) : Byte;
function NoLastBackSlash( s : string ) : string;
procedure TokenList( const s, t : string; ts : TStringList);
function hextoint( s : string ) : Longint;
function wordtostr( w : word ) : string;

function stringisdecimal( s : string ) : boolean;
function stringishex( s : string ) : boolean;

implementation

function Trim(cString: string): string;
{trim off any spaces and return the string}
begin
	 Result := cString;
	 while (Length(result) > 0) and (Result[Length(result)] = ' ') do
		 SetLength( result, ord(Length(result) - 1) );
end;

function AllTrim(cString: string): string;
{trim off any whitespaces and return the string}
var
	 startPos, endPos: integer;
const
  whitespace : string[5] = ' '+#9+#255+#10+#13;
begin
	startPos := 1;
	endPos   := Length(cString);

	while (startPos < endpos) and
    ( pos( cString[startPos], whitespace)>0 ) do
		Inc(startPos);
	while (endPos > startPos) and
    ( pos( cString[endPos], whitespace)>0 ) do
		Dec(endPos);
	if (endPos = startPos) and
    ( pos( cString[endPos], whitespace)>0 ) then
		Result := ''
	else
		Result := Copy(cString, startPos, endPos-startPos+1);
end;

function PadR(cString: string; nLen: integer): string;
{make certain the string is exactly nLen character}
begin
	if (Length(cString) <> nLen) then
		if Length(cString) > nLen then
      Result := Copy(cString,1,nLen)
    else
      Result := cString + Space(nLen-Length(cString))
  else
    Result := cString;
end;

function LeftStr(cString: string; nLen: integer): string;
{return the nLen left most substring}
begin
	if nLen = 0 then
		Result := ''
	else if (Length(cString) > nLen) then
		Result := Copy(cString,1,nLen)
	else
		Result := cString;
end;

function Right(cString: string; nLen: integer): string;
begin
	if nLen = 0 then
		Result := ''
	else if (Length(cString) > nLen) then
		Result := Copy(cString,Length(cString)-nLen+1, nLen)
	else
		 Result := cString;
end;

function Space(nLen: integer): string;
{return the number of spaces asked for}
begin
	 Result := Replicate(' ', nLen);
end;

function Replicate(c: char; nLen: integer): string;
{return a string containing nLen times the character c}
var
	 i: integer;
begin
	 Setlength( Result , nLen );
	 for i := 1 to nLen do Result[i] := c;
   { Das ist schneller als:
    result := '';
    for i := 1 to nlen do Result := Result + c;
    knito nov 1999
   }
end;

function Empty(cString: string): boolean;
{returns true if the string is empty of non-spaces, false otherwise}
begin
	 if Trim(cString) = '' then
		 Result := true
	 else
		 Result := false;
end;

function IntToNullStr(x, stellen : longint) : string;
var
	work : string;
begin
  work := Saveinttostr(x); 
	work := replicate('0', stellen) + work;
	work := right( work, stellen );
	result := work;
end;

function doubletoint( x : double ): longint;
var s : string;
begin
	{ffFixed baut auf jeden Fall ein Komma an fester Stelle ein.}
	s := floattostrf( x, ffFixed, 15, 2 );
	{Kopiere Anteil vor dem Komma in einen STRING}
	s := copy( s, 1, pos( ',', s )-1);
	{Umwandelnd in Integer}
	result := savestrtoint( s );
end;

function inttodouble( x : longint ) : double;
var s : string;
begin
	{Das klappt immer, da kein Komma entsteht}
	s := saveinttostr( x ); 
	{Umwandeln in Float}
	result := strtofloat( s );
end;

function lastpos(substring, s : string ) : Byte;
var
	i : integer;
	found : boolean;

begin
	found := false;
	i := length(s);
	result := 0;

	while ((not found) and (i>0)) do begin
		if s[i] = substring then begin
			found := true;
			result := i;
		end;
		i := i - 1;
	end;

end;

function NoLastBackSlash( s : string ) : string;
begin
	while (right( s, 1 ) = '\') and (length( s ) > 0) do begin
		s := copy( s, 1, length( s ) - 1 );
	end;
	result := s;
end;

procedure TokenList( const s, t : string; ts : TStringList);
var
	i : integer;
	work : string;
begin
	work := '';
	ts.clear;
	for i := 1 to length( s ) do begin
		{ Wenn Zeichen in Trennzeichenliste enthalten,
			dann bisherigen String in Liste aufnehmen,
			wenn der String NICHT empty() ist.}
		if pos( s[i], t ) > 0 then begin
			if not empty( work ) then ts.add( work );
			work := '';
		end else begin
			work := work + s[i];
		end;
	end;
	{ Letzten Rest noch dranknallen }
	if not empty( work ) then ts.add( work );
end;

function hextoint( s : string ) : Longint;
var i,p,l : integer;
const	digits : string = '0123456789ABCDEF';
begin
	result := 0;
	l := length(s);
	if l > 0 then begin
		for i := 1 to l do begin
			p := pos( upcase(s[i]), digits );
			if p > 0 then begin
				result := result shl 4;  {Schnell mit 16 Multiplizieren}
				result := result + (p-1);
			end;
		end;
	end;
end;

function wordtostr( w : word ) : string;
var d, r : integer;
begin
{
 Das Problem ist, da delphi den Wert 65535 intern IMMER als Integer darstellt,
 auch wenns ein word ist. Wenn ich sage inttostr(65535) kommt -1 raus, weil
 vorher nach int konvertiert wird. Bei Integern nimmt delphi automatisch das
 kleinste, passende Format, das wre hier grade noch die 2-Byte-Int.
 Ich will aber nicht -1 dastehen haben, ich will meine 65535!
}
	result := '';
	d := 1;
	while d <> 0 do begin
		d := w div 10;
		r := w mod 10;
		result := chr( r+48 )+result;
		w := d;
	end;
end;

function stringisdecimal( s : string ) : boolean;
var l, i : integer;
const	digits : string = '0123456789';
begin
	result := false;
	s := alltrim( s );
	if pos( s[1], '-+' ) > 0 then s := right( s, length( s ) - 1 );
	l := length( s );
	if l > 0 then begin
		result := true;
		for i := 1 to l do begin
			if pos( s[i], digits ) = 0 then begin
				result := false;
				break;
			end;
		end;
	end;
end;

function stringishex( s : string ) : boolean;
var l, i : integer;
const	digits : string = '0123456789ABCDEF';
begin
	result := false;
	s := alltrim( s );
	if pos( s[1], '-+' ) > 0 then s := right( s, length( s ) - 1 );
	if pos( s[length(s)], 'xXhH$' ) > 0 then s := leftstr( s, length(s) - 1 );
	l := length( s );
	if l > 0 then begin
		result := true;
		for i := 1 to l do begin
			if pos( upcase(s[i]), digits ) = 0 then begin
				result := false;
				break;
			end;
		end;
	end;
end;

function IntToSpaceStr(x, stellen : longint) : string;
var
	work : string;
begin
  work := Saveinttostr(x);
	work := replicate(' ', stellen) + work;
	work := right( work, stellen );
	result := work;
end;

function SaveIntToStr( x : longint ) : string;
begin
  try
    result := inttostr( x ) ;
  except
    result := '0';
  end;
end;

function SaveStrToInt( s : string ) : longint;
begin
  try
    result := strtoint( s );
  except
    result := 0;
  end;
end;

function SaveStrToFloat( s : string ) : Extended;
begin
  try
    result := strtoint( s );
  except
    result := 0;
  end;
end;


end.
